"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Service = void 0;
const nodemailer_1 = require("nodemailer");
const debug_1 = __importDefault(require("debug"));
const debug = (0, debug_1.default)('feathers-mailer');
__exportStar(require("nodemailer"), exports);
__exportStar(require("./types"), exports);
class Service {
    constructor(transport, defaults) {
        debug('constructor', transport);
        if (!transport) {
            throw new Error('feathers-mailer: constructor `transport` must be provided');
        }
        this.transporter = (0, nodemailer_1.createTransport)(transport, defaults);
    }
    async _create(body, params) {
        debug('create', body, params);
        // TODO maybe body should be text/html field
        // and params is rest of options
        // https://github.com/nodemailer/nodemailer#set-up-smtp says:
        // If callback argument is not set then the method returns a Promise object.
        return await this.transporter.sendMail(body);
    }
    create(body, params) {
        return this._create(body, params);
    }
}
exports.Service = Service;
function init(transport, defaults) {
    return new Service(transport, defaults);
}
exports.default = init;
if (typeof module !== 'undefined') {
    module.exports = Object.assign(init, module.exports);
}
//# sourceMappingURL=index.js.map